/***************************************************************************
                          kmamerundoc.cpp  -  KDE frontend for M.A.M.E
                             -------------------
    begin                : Sun Jan 23 12:43:32 CET 2000
    copyright            : (C) 2000 by Jrgen Vigna
    email                : jug@sad.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// include files for Qt
#include <qdir.h>
#include <qfileinfo.h>
#include <qwidget.h>

// include files for KDE
#include <kapplication.h>
#include <kmessagebox.h>

// application specific includes
#include "kmamerundoc.h"
#include "kmamerun.h"
#include "kmamerunview.h"

QList<KMameRunView> *KMameRunDoc::pViewList = 0L;

KMameRunDoc::KMameRunDoc(QWidget *parent, const char *name) : QObject(parent, name)
{
  if(!pViewList)
  {
    pViewList = new QList<KMameRunView>();
  }
}

KMameRunDoc::~KMameRunDoc()
{
}

void KMameRunDoc::addView(KMameRunView *view)
{
  pViewList->append(view);
}

void KMameRunDoc::removeView(KMameRunView *view)
{
  pViewList->remove(view);
}

void KMameRunDoc::slotUpdateAllViews(KMameRunView *sender)
{
  KMameRunView *w;
  if(pViewList)
  {
    for(w=pViewList->first(); w!=0; w=pViewList->next())
    {
      if(w!=sender)
        w->repaint();
    }
  }

}
