/***************************************************************************
                          kmamerundoc.h  -  KDE frontend for M.A.M.E
                             -------------------
    begin                : Sun Jan 23 12:43:32 CET 2000
    copyright            : (C) 2000 by Jrgen Vigna
    email                : jug@sad.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMAMERUNDOC_H
#define KMAMERUNDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

#include "kmamerunview.h"

// include files for QT
#include <qobject.h>
#include <qstring.h>
#include <qlist.h>

// forward declaration of the KMameRun classes
//class KMameRunView;

/**	KMameRunDoc provides a document object for a document-view model.
  *
  * The KMameRunDoc class provides a document object that can be used in
  * conjunction with the classes KMameRunApp and KMameRunView to create a
  * document-view model for standard KDE applications based on KApplication
  * and KTMainWindow. Thereby, the document object is created by the
  * KMameRunApp instance and contains the document structure with the
  * according methods for manipulation of the document data by KMameRunView
  * objects. Also, KMameRunDoc contains the methods for serialization of the
  * document data from and to files.
  *
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team. 	
  * @version KDevelop version 0.4 code generation
  */
class KMameRunDoc : public QObject
{
  Q_OBJECT
  public:
    /** Constructor for the fileclass of the application */
    KMameRunDoc(QWidget *parent, const char *name=0);
    /** Destructor for the fileclass of the application */
    ~KMameRunDoc();

    /** adds a view to the document which represents the document contents.
	Usually this is your main view.
    */
    void addView(KMameRunView *view);
    /** removes a view from the list of currently connected views */
    void removeView(KMameRunView *view);
	
  public slots:
    /** calls repaint() on all views connected to the document object and is
     *	called by the view by which the document has been changed.
     *  As this view normally repaints itself, it is excluded from the
     *  paintEvent.
     */
    void slotUpdateAllViews(KMameRunView *sender);
 	
  public:	
    /** the list of the views currently connected to the document */
    static QList<KMameRunView> *pViewList;	
};

#endif // KMAMERUNDOC_H
