/***************************************************************************
                          main.cpp  -  KDE frontend for M.A.M.E
                             -------------------
    begin                : Sun Jan 23 12:43:32 CET 2000
    copyright            : (C) 2000 by Jrgen Vigna
    email                : jug@sad.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kmamerun.h"

#include <qstring.h>

#include <kcmdlineargs.h>
#include <kaboutdata.h>
#include <klocale.h>

QString globalGameName;
QString globalGameFullName;
QString debugFlag;

static const char *description =
I18N_NOOP("KMameRun is a KDE frontend for XMame (http://xmame.mame.org)");
	
int main(int argc, char *argv[])
{
	debugFlag = getenv("DEBUG");

	KAboutData aboutData( "kmamerun", I18N_NOOP("KMameRun"),
						  VERSION, description, KAboutData::License_GPL,
						  "(c) 2001, Jrgen Vigna", 0, 0, "jug@lyx.org");
	aboutData.addAuthor("Juergen Vigna",
						I18N_NOOP("Original Author and Maintainer"),
						"jug@lyx.org");
	aboutData.addAuthor("David Bishop",
						I18N_NOOP("Developer (ported to KDE3)"),
						"tech@bishop.dhs.org");

	KCmdLineArgs::init(argc, argv, &aboutData);
	KApplication app;

	if (app.isRestored()) {
		RESTORE(KMameRunApp);
	} else {
		KMameRunApp *kmamerun = new KMameRunApp();
		kmamerun->show();
	}
	return app.exec();
}  
