/***************************************************************************
                          maindialog.h  -  KDE frontend for M.A.M.E
                             -------------------
    begin                : Sun Jan 23 2000
    copyright            : (C) 2000 by Jrgen Vigna
    email                : jug@sad.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef MAINDIALOG_H
#define MAINDIALOG_H

#include <qwidget.h>
#include <qlistview.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <qlabel.h>

#include <qwidget.h>

#include "gamelist.h"

class KIconLoader;

/**
  *@author Jrgen Vigna
  */

class MainDialog : public QWidget  {
	Q_OBJECT

	friend class QFileDialog;
	friend class KProcess;
	friend class QLabel;
	friend class QLineEdit;
   
public: 
    enum {
        OPEN_READWRITE 	= 1, 
        OPEN_READONLY 	= 2, 
        OPEN_INSERT	= 4
    };
    bool
        showLogfile;
    int
		nrOfElements;
    unsigned int
        showFlag;
	
    MainDialog(QWidget *parent=0, const char *name=0,
               unsigned int sf=0, int so=1);
    ~MainDialog();
    bool RunGame(QListViewItem *);
    int SetFileName(const char* fname);
    int totMinimumHeight();
    void toggleLogfile();
    void loadListbox(bool reinit = false);
    void reloadListbox(bool reinit = true);
    void setSortMode(int mode);
    void updateCurrentItem();
	
protected slots:
    void RunGameCB(QListViewItem *);
    void RunCurrentGame();
    void ReadStderr(KProcess *, char *buffer, int buflen);
    void ReadStdout(KProcess *, char *buffer, int buflen);
    void RunGameDone(KProcess*);
    void gameSelectCB(QListViewItem *);
    void findFullGame(const QString&);
    void findGame(const QString&);

protected:
    void initDialog();
    //Generated area. DO NOT EDIT!!!(begin)
	QListView *gamelistview;
	QPushButton *imagebutton;
	QLineEdit *inputFind;
	QTextEdit *error_textedit;
	QLabel *lableFind;
	QLabel *lableFullFind;
	QLineEdit *inputFullFind;
    //Generated area. DO NOT EDIT!!!(end)
    virtual void resizeEvent (QResizeEvent *rse);    
    void setPos(QLabel *lab, QLineEdit *le);
    int getGameType(const char *cname);
    int getGamePriority(const char *cname);


signals:
    void gameSelected();

private: 
    QString
        gameName,
        current_directory;
//    LogListBox
//        *error_listbox;
    unsigned int
        gameNameLen,
        gameNameFullLen;
    KIconLoader * il;
    GameList * gl;
    static QString m_str;

    QFileDialog* getFileDialog(const char* captiontext);
    int SetFileName();
    void SetGamePixmap(QListViewItem *);
    unsigned int CheckRomsetExists(const char * romdir, const char * gname);
    bool CheckRomsetValid(GameList &, unsigned int size, const char * gname);
};

#endif
