/***************************************************************************
                          preferences.h  -  KDE frontend for M.A.M.E
                             -------------------
    begin                : Sun Jan 23 2000
    copyright            : (C) 2000 by Jrgen Vigna
    email                : jug@sad.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef Preferences_included
#define Preferences_included

#include <qwidget.h>
#include <qstringlist.h>

#include "prefgeneral.h"
#include "prefvideo.h"
#include "prefaudio.h"
#include "prefinput.h"
#include "prefgame.h"
#include "prefmisc.h"

class KTabCtl;
class QPushButton;
class QLineEdit;
class QLabel;

class Preferences : public QWidget
{
    Q_OBJECT

public:
    Preferences();
    ~Preferences();
    void readConfig();
    void writeGameConfig(QString const gname);
    const QString optionString(const char *cname = 0);
    struct general_prefs prefGeneral;
    struct misc_prefs  prefMisc;
    struct game_prefs  prefGame;
    struct video_prefs prefVideo;
    struct audio_prefs prefAudio;
    struct input_prefs prefInput;
    PrefGame *prefgam; 
    PrefMisc *prefmisc;

signals:
    void commitChanges();
    void prefHide();
    void prefGameChanged();

protected slots:
    void setDefaults();	
    void ok();
    void apply();
    void cancel();

protected:
    void writeConfig();
    void closeEvent(QCloseEvent *e);
    void setPos(QLabel *lab, QLineEdit *le);
    void setDefaultConfig();

    QString     mamecmd;
    KTabCtl     *tabbar;
    QPushButton *b_default;
    QPushButton *b_ok;
    QPushButton *b_apply;
    QPushButton *b_cancel;
    
    PrefGeneral *prefgen;
    PrefVideo *prefvid;
    PrefAudio *prefaud;
    PrefInput *prefinp;
   
    struct general_prefs defPrefGeneral;
    struct misc_prefs  defPrefMisc;
    struct game_prefs  defPrefGame;
    struct video_prefs defPrefVideo;
    struct audio_prefs defPrefAudio;
    struct input_prefs defPrefInput;
};
#endif // Preferences_included
