/***************************************************************************
                          prefgame.h  -  KDE frontend for M.A.M.E
                             -------------------
    begin                : Sun Jan 23 2000
    copyright            : (C) 2000 by Jrgen Vigna
    email                : jug@sad.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREFGAME_H
#define PREFGAME_H

#include <qwidget.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qcheckbox.h>

#include <qwidget.h>

/**
  *@author Jrgen Vigna
  */

struct game_prefs {
    QString game_name;
    QString game_full_name;
    int priority;
    int type;
    bool default_opt;
};

class PrefGame : public QWidget  {
    Q_OBJECT
public: 
    PrefGame(QWidget *parent=0, const char *name=0);
    ~PrefGame();
    void setPrefs(struct game_prefs *prefs);
    bool writeConfig(struct game_prefs *prefs, const char *cname);
    void readConfig(struct game_prefs *prefs, const char *cname);
    bool useDefaultOpt();
    QString getGameTypeString(int type);

protected: 
    void initDialog();
	QLabel *labelGameName;
	QLabel *labelPriority;
	QComboBox *comboPriority;
	QLabel *labelType;
	QComboBox *comboType;
	QCheckBox *checkDefaultOpt;

private: 
    int
        oldPriority,
        oldType;
};

#endif
