/***************************************************************************
                          prefmisc.cpp  -  KDE frontend for M.A.M.E
                             -------------------
    begin                : Mon Jul 24 2000
    copyright            : (C) 2000 by Jrgen Vigna
    email                : jug@sad.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "prefmisc.h"

#include <qcombobox.h>

#include <kapplication.h>
#include <ksimpleconfig.h>
#include <kstandarddirs.h>

PrefMisc::PrefMisc(QWidget *parent, const char *name)
	: QWidget(parent,name)
{
    initDialog();
    comboDefaultExt->clear();
    comboDefaultExt->setAutoResize(true);
    for(int i=0; i < 4; ++i)
	comboDefaultExt->insertItem(getDefaultExt(i));
}

PrefMisc::~PrefMisc()
{
}

void PrefMisc::setPrefs(struct misc_prefs *prefs)
{
    comboDefaultExt->setCurrentItem(prefs->default_ext);
    inputExtraOpts->validateAndSet(prefs->extra_options, 0, 0, 0);
}

bool PrefMisc::writeConfig(struct misc_prefs *, const char *cname)
{
    QString
        cgroup = cname,
        aConfigName = locateLocal("config", "/kmamerunrc");
        //aConfigName = KApplication::localconfigdir() + "/kmamerunrc";

    cgroup += "Misc";
    KSimpleConfig config(aConfigName);
    config.setGroup(cgroup);
    
    config.writeEntry("default_ext",comboDefaultExt->currentItem());
    config.writeEntry("extra_options",inputExtraOpts->text());
    return false;
}

void PrefMisc::readConfig(struct misc_prefs *prefs, const char *cname)
{
    QString
        cgroup = cname,
        aConfigName = locateLocal("config", "/kmamerunrc");
        //aConfigName = KApplication::localconfigdir() + "/kmamerunrc";

    cgroup += "Misc";
    KSimpleConfig config(aConfigName);
    config.setGroup(cgroup);
    if (config.hasKey("default_ext"))
        prefs->default_ext = config.readNumEntry("default_ext");
    if (config.hasKey("extra_options"))
        prefs->extra_options = config.readEntry("extra_options");
}


const QString PrefMisc::optionString(struct misc_prefs *, struct misc_prefs *prefs)
{
    QString
        opt;

    if (!prefs->extra_options.isEmpty())
	opt += prefs->extra_options;

    return opt;
}

const char * PrefMisc::getDefaultExt(int num)
{
    switch(num) {
    case 0:
	return "png";
    case 1:
	return "jpg";
    case 2:
	return "gif";
    case 3:
	return "xpm";
    case 4:
	return "ppm";
    default:
	break;
    }
    return "";
}
