/***************************************************************************
                          prefvideo.h  -  KDE frontend for M.A.M.E
                             -------------------
    begin                : Sun Jan 23 2000
    copyright            : (C) 2000 by Jrgen Vigna
    email                : jug@sad.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PREFVIDEO_H
#define PREFVIDEO_H

//Generated area. DO NOT EDIT!!!(begin)
#include <qwidget.h>
#include <qlabel.h>
#include <qcombobox.h>
#include <qspinbox.h>
#include <qcheckbox.h>
//Generated area. DO NOT EDIT!!!(end)

#include <qwidget.h>

/**
  *@author Jrgen Vigna
  */

struct video_prefs {
    bool X11;
    QString display;
    int heightscale;
    int frameskip;
    int brightness;
    bool use_mitshm;
    bool use_xsync;
    bool use_dirty;
    bool private_colormap;
    bool use_scanlines;
    bool use_artwork;
    bool throttle;
    bool rotation;
    bool ror90;
    bool rol90;
    bool flip_Xaxis;
    bool flip_Yaxis;
    bool run_root_window;
    bool run_full_screen;
};

class PrefVideo : public QWidget  {
    Q_OBJECT
public: 
    PrefVideo(QWidget *parent=0, const char *name=0);
    ~PrefVideo();
    void setPrefs(struct video_prefs *prefs);
    void writeConfig(struct video_prefs *prefs, const char *cname);
    void readConfig(struct video_prefs *prefs, const char *cname);
    const QString optionString(struct video_prefs *, struct video_prefs *);

protected: 
    void initDialog();

    //Generated area. DO NOT EDIT!!!(begin)
    QLabel *labelScale;
    QComboBox *comboScale;
    QLabel *labelFrameskip;
    QComboBox *comboFrameskip;
    QLabel *labelBrightness;
    QSpinBox *sboxBrightness;
    QCheckBox *checkSharedMem;
    QCheckBox *checkRefresh;
    QCheckBox *checkDirtyRec;
    QCheckBox *checkPrivateColmap;
    QCheckBox *checkUseScanlines;
    QCheckBox *checkUseArtwork;
    QCheckBox *checkThrottle;
    QCheckBox *checkNoRotate;
    QCheckBox *checkRotate90Right;
    QCheckBox *checkRotate90Left;
    QCheckBox *checkFlipXAxis;
    QCheckBox *checkFlipYAxis;
    QCheckBox *checkRunRootWindow;
    QCheckBox *checkFullScreen;
    //Generated area. DO NOT EDIT!!!(end)

private: 
};

#endif
